#include <math.h>

#include "YRTScene.h"
#include "YRTTriangle.h"
#include "YRTUtils.h"

#pragma hdrstop

TYRTScene::TYRTScene(void)
{
    ShapeList = new TObjectList();
}

TYRTScene::~TYRTScene(void)
{
    delete ShapeList;
}

void TYRTScene::GenerateExample_01Triangles(int AWidth, int AHeight)
{
    TYRTTriangle *LTriangle;

    ShapeList->Clear();

    float y = AWidth / 12;
    float z = AWidth  / 6;

    // Plane:
    LTriangle = new TYRTTriangle;
    LTriangle->Points[0] = TYRTVector(0, y, z);
    LTriangle->Points[1] = TYRTVector(AWidth, y, z);
    LTriangle->Points[2] = TYRTVector(0, y, z + AWidth);
    LTriangle->Color = rgb(0, 0, 255);
    ShapeList->Add(LTriangle);
    LTriangle = new TYRTTriangle;
    LTriangle->Points[0] = TYRTVector(AWidth, y, z + AWidth);
    LTriangle->Points[1] = TYRTVector(AWidth, y, z);
    LTriangle->Points[2] = TYRTVector(0, y, z + AWidth);
    LTriangle->Color = rgb(255, 0, 0);
    ShapeList->Add(LTriangle);

    // Crown:
    const int count = 12;
    for (int i = 0; i < count; i++)
    {
        float h = 100 + (rand() * 1.0 / RAND_MAX) * AHeight * 2 / 3;
        float r = AWidth / 3;

        LTriangle = new TYRTTriangle;

        LTriangle->Points[0].x = AWidth / 2 + r * sin(i * 2 * PI / count + PI / count / 4);
        LTriangle->Points[0].y = y + 0;
        LTriangle->Points[0].z = z + AWidth / 2 + r * cos(i * 2 * PI / count + PI / count / 4);

        LTriangle->Points[1].x = AWidth / 2 + r * sin((i + 1) * 2 * PI / count - PI / count / 4);
        LTriangle->Points[1].y = y + 0;
        LTriangle->Points[1].z = z + AWidth / 2 + r * cos((i + 1) * 2 * PI / count - PI / count / 4);

        LTriangle->Points[2].x = AWidth / 2 + (r + h / 8) * sin(i * 2 * PI / count + PI / count);
        LTriangle->Points[2].y = y + h;
        LTriangle->Points[2].z = z + AWidth / 2 + (r + h / 8) * cos(i * 2 * PI / count + PI / count);

        LTriangle->Color = rgb(0, i * 255 / count, 0);

        ShapeList->Add(LTriangle);
    }
}

int TYRTScene::GetCount(void)
{
    if (ShapeList)
        return ShapeList->Count;
    else
        return 0;
}

TYRTShape* TYRTScene::GetShape(int AIndex)
{
    if (ShapeList)
        if (AIndex >= 0 && AIndex < ShapeList->Count)
            return (TYRTShape*)ShapeList->Items[AIndex];
        else
            return NULL;
    else
        return NULL;
}

